/* routes.h

   Written by Frederic Bois
   22 June 2014

   Copyright (c) 2014 Frederic Bois.

   This code is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   See the GNU General Public License at <http://www.gnu.org/licenses/> 

   -- Revisions -----
     Logfile:  %F%
    Revision:  %I%
        Date:  %G%
     Modtime:  %U%
      Author:  @a
   -- SCCS  ---------

   Routes is a DAG checking algorithm, unused in fact.
*/

#ifndef ROUTES_H_DEFINED


/* ----------------------------------------------------------------------------
   Inclusions
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>


/* ----------------------------------------------------------------------------
   Type definitions
*/

#ifndef TRUE
typedef int BOOL;
#define TRUE  1
#define FALSE 0
#endif


/* ----------------------------------------------------------------------------
   Prototypes
*/
void   ComputeAllRoutes (int nNodes, int **adjacency, int **routes);
void   InitRoutes (int nNodes);
BOOL   IsDAG_w_routes (int nNodes, int **adjacency, int **routes);
void   RoutesAddEdge (int nNodes, int **routes, int parent, int child);
void   RoutesRemoveEdge (int nNodes, int **routes, long parent, long child);


/* ----------------------------------------------------------------------------
   Global declarations
*/

// route matrices, will be inited in InitRoutes
extern int **routes;     // route matrix for DAGs
extern int **routes_tmp; // storage for route matrix


#define ROUTES_H_DEFINED
#endif

/* end */
